'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _path = require('path');

var _extend = require('extend');

var _extend2 = _interopRequireDefault(_extend);

var _nodemon = require('nodemon');

var _nodemon2 = _interopRequireDefault(_nodemon);

var _ServerCompiler = require('./compilers/ServerCompiler');

var _ServerCompiler2 = _interopRequireDefault(_ServerCompiler);

var _ClientCompiler = require('./compilers/ClientCompiler');

var _ClientCompiler2 = _interopRequireDefault(_ClientCompiler);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let Loader = (_temp = _class = class Loader {

	constructor(config) {
		this.restart = () => {
			if (!this.config.sources.server || !this.config.start) {
				return;
			}

			_nodemon2.default.restart();
		};

		this.config = (0, _extend2.default)(true, {}, Loader.settings, { prod: !config.dev, watch: config.dev }, config);
		// TODO: validate config
		if (this.config.sources.server) {
			this.serverCompiler = new _ServerCompiler2.default(_extends({}, this.config, {
				server: true,
				client: false
			}));
		}

		if (this.config.sources.client) {
			this.clientCompiler = new _ClientCompiler2.default(_extends({}, this.config, {
				server: false,
				client: true
			}));
		}
	}

	build() {
		const promiseList = [];

		if (this.config.sources.server) {
			promiseList.push(this.serverCompiler.build({ restart: this.restart }));
		}

		if (this.config.sources.client) {
			promiseList.push(this.clientCompiler.build());
		}

		return Promise.all(promiseList);
	}

	start() {
		if (!this.config.sources.server || !this.config.start) {
			return;
		}

		(0, _nodemon2.default)({
			script: (0, _path.resolve)(this.config.root, this.config.start),
			exec: 'node --inspect',
			ignore: ['*'],
			watch: ['ThisIsAFakeDirToDisableNodemonWatch/'],
			ext: 'noop',
			verbose: true
		}).on('log', ({ colour: colorCodedLog }) => console.log(colorCodedLog));
	}

}, _class.settings = {
	root: '',
	dev: false,
	library: false,
	define: {},
	start: '',
	sources: {}
}, _temp);
exports.default = Loader;