'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _path = require('path');

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _webpackDevServer = require('webpack-dev-server');

var _webpackDevServer2 = _interopRequireDefault(_webpackDevServer);

var _config = require('../webpack/config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

let ClientCompiler = class ClientCompiler {

	constructor(config) {
		this.config = config;
		this.webpackConfig = (0, _config2.default)(this.config);
		this.compiler = (0, _webpack2.default)(this.webpackConfig);
		this.initialCompilationComplete = false;
	}

	build() {
		var _this = this;

		return new Promise((() => {
			var _ref = _asyncToGenerator(function* (resolve) {
				if (_this.config.dev) {
					if (_this.config.library) {
						_this.compiler.watch({
							aggregateTimeout: 300,
							poll: true
						}, function (...args) {
							return _this.onCompilationDone(...args, resolve);
						});
					} else {
						_this.compiler.plugin('done', function (stats) {
							return _this.onCompilationDone(null, stats, resolve);
						});
						new _webpackDevServer2.default(_this.compiler, {
							compress: true,
							historyApiFallback: true,
							hot: true,
							noInfo: true,
							publicPath: `http://localhost:${_this.config.devServerPort}/`,
							contentBase: (0, _path.resolve)(_this.config.root, 'dist/client'),
							stats: {
								colors: true
							},
							headers: {
								'Access-Control-Allow-Origin': '*',
								'Access-Control-Allow-Methods': 'GET, POST, PUT, DELETE, PATCH, OPTIONS',
								'Access-Control-Allow-Headers': 'X-Requested-With, content-type, Authorization'
							}
						}).listen(_this.config.devServerPort);
					}
				} else {
					_this.compiler.run(function (...args) {
						return _this.onCompilationDone(...args, resolve);
					});
				}
			});

			return function (_x) {
				return _ref.apply(this, arguments);
			};
		})());
	}

	onCompilationDone(err, stats, resolve) {
		if (err) {
			console.error(err.stack || err);
			if (err.details) {
				console.error(err.details);
			}
			return;
		}

		console.log(stats.toString({
			chunks: false,
			colors: true
		}));

		if (!this.initialCompilationComplete) {
			this.initialCompilationComplete = true;
			resolve();
		}
	}
};
exports.default = ClientCompiler;