'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extend = require('extend');

var _extend2 = _interopRequireDefault(_extend);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const sharedConfig = {
	babelrc: false,
	presets: [],
	plugins: ['syntax-decorators', 'syntax-async-functions', 'transform-decorators-legacy', 'transform-class-properties', 'transform-object-rest-spread', 'transform-async-to-generator']
};

exports.default = config => {
	let dev = config.dev,
	    prod = config.prod,
	    client = config.client,
	    server = config.server,
	    alias = config.alias;


	let babelConfig = (0, _extend2.default)(true, {}, sharedConfig);

	if (server) {
		babelConfig.presets = [
		// [
		// 	'env',
		// 	{
		// 		targets: {
		// 			node: 6
		// 		},
		// 		modules: false,
		// 		useBuiltIns: true
		// 	}
		// ],
		['latest-node6', {
			'object-rest': true,
			modules: false
		}], 'react'];
	}

	if (client) {
		babelConfig.presets = [['env', {
			modules: false,
			useBuiltIns: true
		}], 'react'];

		if (dev) {
			babelConfig.plugins.unshift('react-hot-loader/babel');
		}
	}

	if (prod) {
		babelConfig.presets.push('react-optimize');
	}

	if (server) {
		alias = alias.server;
	} else {
		alias = alias.client;
	}

	babelConfig.plugins.push(['module-resolver', {
		alias
	}]);

	return babelConfig;
};