'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _entry = require('./entry');

var _entry2 = _interopRequireDefault(_entry);

var _output = require('./output');

var _output2 = _interopRequireDefault(_output);

var _rules = require('./rules/rules');

var _rules2 = _interopRequireDefault(_rules);

var _resolveLoader = require('./resolveLoader');

var _resolveLoader2 = _interopRequireDefault(_resolveLoader);

var _plugins = require('./plugins');

var _plugins2 = _interopRequireDefault(_plugins);

var _devtool = require('./devtool');

var _devtool2 = _interopRequireDefault(_devtool);

var _target = require('./target');

var _target2 = _interopRequireDefault(_target);

var _externals = require('./externals');

var _externals2 = _interopRequireDefault(_externals);

var _node = require('./node');

var _node2 = _interopRequireDefault(_node);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = config => {
	let root = config.root;
	var _config$alias = config.alias;
	let alias = _config$alias === undefined ? {} : _config$alias;


	alias = _extends({
		client: {},
		server: {}
	}, alias);

	config.alias = alias;

	return {
		context: root,
		entry: (0, _entry2.default)(config),
		output: (0, _output2.default)(config),
		module: {
			rules: (0, _rules2.default)(config)
		},
		resolve: {
			modules: [root, 'node_modules']
		},
		resolveLoader: (0, _resolveLoader2.default)(config),
		plugins: (0, _plugins2.default)(config),
		devtool: (0, _devtool2.default)(config),
		target: (0, _target2.default)(config),
		externals: (0, _externals2.default)(config),
		node: (0, _node2.default)(config)
	};
};