'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extend = require('extend');

var _extend2 = _interopRequireDefault(_extend);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = config => {
	let dev = config.dev,
	    prod = config.prod,
	    client = config.client,
	    server = config.server,
	    library = config.library,
	    sources = config.sources,
	    devServerPort = config.devServerPort;


	let entries = {};

	if (server) {
		entries = sources.server;
	}

	if (client) {
		if (dev && !library) {
			for (const name in sources.client) {
				const entry = sources.client[name];

				entries[name] = ['react-hot-loader/patch',
				// activate HMR for React

				`webpack-dev-server/client?http://localhost:${devServerPort}`,
				// bundle the client for webpack-dev-server
				// and connect to the provided endpoint

				'webpack/hot/only-dev-server'];

				if (Array.isArray(entry)) {
					entries[name] = [...entries[name], ...entry];
				} else {
					entries[name].push(entry);
				}
			}
		}

		if (prod || library) {
			entries = (0, _extend2.default)(true, {}, sources.client);
		}
	}

	return entries;
};