'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _path = require('path');

var _extend = require('extend');

var _extend2 = _interopRequireDefault(_extend);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const sharedOutput = {
	chunkFilename: '[name]-[chunkhash].js'
};

exports.default = config => {
	const root = config.root,
	      dev = config.dev,
	      prod = config.prod,
	      library = config.library,
	      client = config.client,
	      server = config.server,
	      devServerPort = config.devServerPort;


	const output = (0, _extend2.default)(true, {}, sharedOutput);

	if (server) {
		output.filename = '[name].js';
		output.path = (0, _path.resolve)(root, 'dist/server');
	}

	if (client) {
		if (library) {
			output.filename = '[name].js';
		} else {
			output.filename = '[name]-[hash].js';
		}

		output.path = (0, _path.resolve)(root, 'dist/client');

		if (dev && !library) {
			output.publicPath = `http://localhost:${devServerPort}/`;
		}

		if (prod && !library) {
			output.publicPath = '/assets/';
		}
	}

	if (library) {
		output.library = library;
		output.libraryTarget = 'commonjs2';
	}

	return output;
};