'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _path = require('path');

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _assetsWebpackPlugin = require('assets-webpack-plugin');

var _assetsWebpackPlugin2 = _interopRequireDefault(_assetsWebpackPlugin);

var _cleanWebpackPlugin = require('clean-webpack-plugin');

var _cleanWebpackPlugin2 = _interopRequireDefault(_cleanWebpackPlugin);

var _extractTextWebpackPlugin = require('extract-text-webpack-plugin');

var _extractTextWebpackPlugin2 = _interopRequireDefault(_extractTextWebpackPlugin);

var _progressBarWebpackPlugin = require('progress-bar-webpack-plugin');

var _progressBarWebpackPlugin2 = _interopRequireDefault(_progressBarWebpackPlugin);

var _uglifyjsWebpackPlugin = require('uglifyjs-webpack-plugin');

var _uglifyjsWebpackPlugin2 = _interopRequireDefault(_uglifyjsWebpackPlugin);

var _extend = require('extend');

var _extend2 = _interopRequireDefault(_extend);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = config => {
	let root = config.root;
	var _config$define = config.define;
	let define = _config$define === undefined ? {} : _config$define,
	    ssr = config.ssr,
	    dev = config.dev,
	    prod = config.prod,
	    client = config.client,
	    server = config.server;


	define = (0, _extend2.default)(true, { server: {}, client: {} }, define);

	let plugins = [new _webpack2.default.DefinePlugin(_extends({
		'process.env': {
			'NODE_ENV': JSON.stringify(dev ? 'development' : 'production')
		},
		SSR_ENABLED: ssr,
		IS_DEVELOPMENT: dev,
		IS_PRODUCTION: prod,
		IS_CLIENT: client,
		IS_SERVER: server
	}, server ? define.server : define.client)), new _webpack2.default.ProvidePlugin({
		THREE: 'three'
	}), new _webpack2.default.NoEmitOnErrorsPlugin(), new _progressBarWebpackPlugin2.default()];

	if (dev) {
		plugins.push(new _webpack2.default.NamedModulesPlugin());
	}

	if (server) {
		if (dev) {
			plugins.push(new _webpack2.default.BannerPlugin({
				banner: 'require("source-map-support").install();',
				raw: true,
				entryOnly: false
			}));
		}

		plugins.unshift(new _cleanWebpackPlugin2.default(['dist/server'], { root }));
	}

	if (client) {
		plugins.push(new _assetsWebpackPlugin2.default({
			path: (0, _path.resolve)(root, 'dist'),
			prettyPrint: true
		}));

		if (dev) {
			plugins.push(new _webpack2.default.HotModuleReplacementPlugin());
		}

		if (prod) {
			plugins = [...plugins, new _uglifyjsWebpackPlugin2.default(), new _extractTextWebpackPlugin2.default('[name]-[id]-[contenthash].css')];
		}

		plugins.unshift(new _cleanWebpackPlugin2.default(['dist/client'], { root }));
	}

	return plugins;
};