'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _babel = require('./babel');

var _babel2 = _interopRequireDefault(_babel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = config => {
	const server = config.server,
	      client = config.client;


	const alias = {
		svg: 'react-svg-loader?jsx=1',
		es5: `babel-loader?${JSON.stringify((0, _babel2.default)(config))}`,
		cssVar: 'postcss-variables-loader?es5=1'
	};

	if (server) {
		alias.copyPath = 'file-loader?emitFile=false&name=[path][name].[ext]';
		alias.copy = 'file-loader?emitFile=false&name=[name].[ext]';
	}

	if (client) {
		alias.copyPath = 'file-loader?name=[path][name].[ext]';
		alias.copy = 'file-loader?name=[name].[ext]';
	}

	return {
		alias
	};
};