'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

exports.default = config => {
	const dev = config.dev,
	      prod = config.prod,
	      server = config.server;


	const options = {
		limit: 5000
	};

	if (dev) {
		options.name = '[name]-[hash].[ext]';
	}

	if (prod) {
		options.name = '[hash].[ext]';
	}

	if (server) {
		options.emitFile = false;
	}

	return {
		test: /\.(eot|woff|woff2|ttf|otf|gif|svg|png|jpe?g)(\?\S+)?$/,
		loader: {
			loader: 'url-loader',
			options
		}
	};
};