'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _postcssImport = require('postcss-import');

var _postcssImport2 = _interopRequireDefault(_postcssImport);

var _postcssCssnext = require('postcss-cssnext');

var _postcssCssnext2 = _interopRequireDefault(_postcssCssnext);

var _extractTextWebpackPlugin = require('extract-text-webpack-plugin');

var _extractTextWebpackPlugin2 = _interopRequireDefault(_extractTextWebpackPlugin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = config => {
	const root = config.root,
	      dev = config.dev,
	      prod = config.prod,
	      client = config.client,
	      server = config.server;


	let loaders = [];

	if (client) {
		if (dev) {
			loaders = ['style-loader', {
				loader: 'css-loader',
				options: {
					sourceMap: true,
					modules: true,
					importLoaders: 1,
					localIdentName: '[path]___[name]__[local]___[hash:base64:5]'
				}
			}, {
				loader: 'postcss-loader',
				options: {
					plugins: () => [(0, _postcssImport2.default)({
						root,
						addDependencyTo: _webpack2.default
					}), (0, _postcssCssnext2.default)()]
				}
			}];
		}

		if (prod) {
			loaders = _extractTextWebpackPlugin2.default.extract({
				fallback: 'style-loader',
				use: [{
					loader: 'css-loader',
					options: {
						minimize: true,
						modules: true,
						importLoaders: 1,
						localIdentName: '[hash:base64:5]'
					}
				}, {
					loader: 'postcss-loader',
					options: {
						plugins: () => [(0, _postcssImport2.default)({
							root,
							addDependencyTo: _webpack2.default
						}), (0, _postcssCssnext2.default)()]
					}
				}]
			});
		}
	}

	if (server) {
		if (dev) {
			loaders = [{
				loader: 'css-loader/locals',
				options: {
					modules: true,
					localIdentName: '[path]___[name]__[local]___[hash:base64:5]'
				}
			}, {
				loader: 'postcss-loader',
				options: {
					plugins: () => [(0, _postcssImport2.default)({
						root,
						addDependencyTo: _webpack2.default
					}), (0, _postcssCssnext2.default)()]
				}
			}];
		}

		if (prod) {
			loaders = [{
				loader: 'css-loader/locals',
				options: {
					modules: true,
					localIdentName: '[hash:base64:5]'
				}
			}, {
				loader: 'postcss-loader',
				options: {
					plugins: () => [(0, _postcssImport2.default)({
						root,
						addDependencyTo: _webpack2.default
					}), (0, _postcssCssnext2.default)()]
				}
			}];
		}
	}

	return {
		test: /^((?!\.global).)*css$/,
		use: loaders
	};
};