'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extractTextWebpackPlugin = require('extract-text-webpack-plugin');

var _extractTextWebpackPlugin2 = _interopRequireDefault(_extractTextWebpackPlugin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = config => {
	const dev = config.dev,
	      prod = config.prod,
	      client = config.client,
	      server = config.server;


	let loaders = [];

	if (client) {
		if (dev) {
			loaders = ['style-loader', {
				loader: 'css-loader',
				options: {
					sourceMap: true,
					importLoaders: 1
				}
			}];
		}

		if (prod) {
			loaders = _extractTextWebpackPlugin2.default.extract({
				fallback: 'style-loader',
				use: [{
					loader: 'css-loader',
					options: {
						minimize: true,
						importLoaders: 1
					}
				}]
			});
		}
	}

	if (server) {
		loaders = ['css-loader/locals'];
	}

	return {
		test: /\.global\.css$/,
		use: loaders
	};
};