'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _babel = require('../babel');

var _babel2 = _interopRequireDefault(_babel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = config => {
	let server = config.server,
	    alias = config.alias;


	if (server) {
		alias = alias.server;
	} else {
		alias = alias.client;
	}

	return [{
		test: /\.jsx?$/,
		include: /@flexverse/,
		enforce: 'pre',
		loader: {
			loader: 'babel-loader',
			options: {
				babelrc: false,
				presets: [],
				plugins: [['module-resolver', {
					alias
				}]]
			}
		}
	}, {
		test: /\.jsx?$/,
		exclude: /node_modules/,
		loader: {
			loader: 'babel-loader',
			options: (0, _babel2.default)(config)
		}
	}];
};